"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Lint = require("tslint");
var ConfigFactory_1 = require("./config/ConfigFactory");
var RuleId_1 = require("./RuleId");
var GeneralRuleUtils_1 = require("./utils/GeneralRuleUtils");
var Rule = /** @class */ (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (sourceFile) {
        var config = ConfigFactory_1.ConfigFactory.createForTestBreakpointRule(this.getOptions());
        if (!GeneralRuleUtils_1.GeneralRuleUtils.isFileInPaths(sourceFile.fileName, config.includePaths)) {
            return [];
        }
        var walker = new StatementsWalker(sourceFile, this.getOptions(), config);
        this.applyWithWalker(walker);
        return walker.getFailures();
    };
    return Rule;
}(Lint.Rules.AbstractRule));
exports.Rule = Rule;
var StatementsWalker = /** @class */ (function (_super) {
    __extends(StatementsWalker, _super);
    function StatementsWalker(sourceFile, options, config) {
        var _this = _super.call(this, sourceFile, options) || this;
        _this.config = config;
        return _this;
    }
    StatementsWalker.prototype.visitCallExpression = function (node) {
        var text = node.getText();
        if (this.config.debugTokens.some(function (token) { return text.startsWith(token); })) {
            this.addFailureAtNode(node.getFirstToken(), GeneralRuleUtils_1.GeneralRuleUtils.buildFailureString("do not hard code breakpoints in the test", RuleId_1.RuleId.TsfFoldersTestWithBreakpoint));
        }
        _super.prototype.visitCallExpression.call(this, node);
    };
    return StatementsWalker;
}(Lint.RuleWalker));
//# sourceMappingURL=tsfFoldersTestWithBreakpointRule.js.map